{=====================================================================}
{ Button Manager for Delphi 2.0 ver 1.0.5 29/Jul./'97                 }
{ http://www.kobira.co.jp/sakura/windows.htm                          }
{ author Seiji-Yasuda seiji@kobira.co.jp                              }
{                                                                     }
{ You may use it freely at your own risk in any kind of environment.  }
{                                                                     }
{ Note:                                                               }
{  2/Jun./'97 ver 0.0.1                                               }
{   first version. unit                                               }
{  11/Jun./'97 ver 0.0.2                                              }
{   unit --> Component.                                               }
{  17/Jun./'97 ver 0.0.3                                              }
{   supported string of Shift key.                                    }
{  14/Jul./'97 ver 1.0.0                                              }
{   supported Event. local release.                                   }
{  22/Jul./'97 ver 1.0.1                                              }
{   check TButton's enabled property.                                 }
{   supported MoveOldFocus                                            }
{  23/Jul./'97 ver 1.0.2                                              }
{   supported push/pop command.                                       }
{   supported push = sleep, pop = non sleep.                          }
{   call MoveOldFocus at pop.                                         }
{  24/Jul./'97 ver 1.0.3                                              }
{   supported, lost of WM_LBUTTONDOWN for IME.                        }
{  25/Jul./'97 ver 1.0.4                                              }
{   supported, FLastKeyCode                                           }
{  29/Jul./'97 ver 1.0.5                                              }
{   made sample.                                                      }
{                                                                     }
{=====================================================================}
unit BtnMng;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

const
  MAX_TABLE = 20;

type
  KeyCode = (none,VF01,VF02,VF03,VF04,VF05,VF06,VF07,VF08,VF09,VF10,VESC,VINS,
             VDEL,VEND,VHOME,VUP,VDOWN,VLEFT,VRIGHT,VRUP,VRDOWN);


  TBtnMng = class(TComponent)
  private
    FButtons:array[0..MAX_TABLE-1] of TButton;
    FKeys:array[0..MAX_TABLE-1] of KeyCode;
    FMsgs:array[0..MAX_TABLE-1] of String;
    FMsgBacks:array[0..MAX_TABLE-1] of String;
    FEnabled:Boolean;
    FDownWait:Integer;
    FOldOnMessage : TMessageEvent;
    FShiftStatus : Boolean;
    FOnShiftDown : TNotifyEvent;
    FOnShiftup : TNotifyEvent;
    FOLDFocus : HWND;
    FPushOLDFocus : HWND;
    FKeyDownStatus : Boolean;
    FSleep:Boolean;
    FLastKeyCode:WORD;
  protected
    procedure SetFEnabled( v:Boolean );
    procedure NewMessage(var Msg: TMsg; var Handled: Boolean);

  public
    constructor Create(aowner : TComponent); override;
    destructor  Destroy; override;
    function    GetShiftStatus:Boolean;
    procedure   MoveOldFocus;
    procedure   Push;
    procedure   Pop;

  published
    property Button01    : TButton read FButtons[ 0] write FButtons[ 0];
    property Button01Key : KeyCode read FKeys[ 0]    write FKeys[ 0];
    property Button01Msg : String  read FMsgs[ 0]    write FMsgs[ 0];
    property Button02    : TButton read FButtons[ 1] write FButtons[ 1];
    property Button02Key : KeyCode read FKeys[ 1]    write FKeys[ 1];
    property Button02Msg : String  read FMsgs[ 1]    write FMsgs[ 1];
    property Button03    : TButton read FButtons[ 2] write FButtons[ 2];
    property Button03Key : KeyCode read FKeys[ 2]    write FKeys[ 2];
    property Button03Msg : String  read FMsgs[ 2]    write FMsgs[ 2];
    property Button04    : TButton read FButtons[ 3] write FButtons[ 3];
    property Button04Key : KeyCode read FKeys[ 3]    write FKeys[ 3];
    property Button04Msg : String  read FMsgs[ 3]    write FMsgs[ 3];
    property Button05    : TButton read FButtons[ 4] write FButtons[ 4];
    property Button05Key : KeyCode read FKeys[ 4]    write FKeys[ 4];
    property Button05Msg : String  read FMsgs[ 4]    write FMsgs[ 4];
    property Button06    : TButton read FButtons[ 5] write FButtons[ 5];
    property Button06Key : KeyCode read FKeys[ 5]    write FKeys[ 5];
    property Button06Msg : String  read FMsgs[ 5]    write FMsgs[ 5];
    property Button07    : TButton read FButtons[ 6] write FButtons[ 6];
    property Button07Key : KeyCode read FKeys[ 6]    write FKeys[ 6];
    property Button07Msg : String  read FMsgs[ 6]    write FMsgs[ 6];
    property Button08    : TButton read FButtons[ 7] write FButtons[ 7];
    property Button08Key : KeyCode read FKeys[ 7]    write FKeys[ 7];
    property Button08Msg : String  read FMsgs[ 7]    write FMsgs[ 7];
    property Button09    : TButton read FButtons[ 8] write FButtons[ 8];
    property Button09Key : KeyCode read FKeys[ 8]    write FKeys[ 8];
    property Button09Msg : String  read FMsgs[ 8]    write FMsgs[ 8];
    property Button10    : TButton read FButtons[ 9] write FButtons[ 9];
    property Button10Key : KeyCode read FKeys[ 9]    write FKeys[ 9];
    property Button10Msg : String  read FMsgs[ 9]    write FMsgs[ 9];
    property Button11    : TButton read FButtons[10] write FButtons[10];
    property Button11Key : KeyCode read FKeys[10]    write FKeys[10];
    property Button11Msg : String  read FMsgs[10]    write FMsgs[10];
    property Button12    : TButton read FButtons[11] write FButtons[11];
    property Button12Key : KeyCode read FKeys[11]    write FKeys[11];
    property Button12Msg : String  read FMsgs[11]    write FMsgs[11];
    property Button13    : TButton read FButtons[12] write FButtons[12];
    property Button13Key : KeyCode read FKeys[12]    write FKeys[12];
    property Button13Msg : String  read FMsgs[12]    write FMsgs[12];
    property Button14    : TButton read FButtons[13] write FButtons[13];
    property Button14Key : KeyCode read FKeys[13]    write FKeys[13];
    property Button14Msg : String  read FMsgs[13]    write FMsgs[13];
    property Button15    : TButton read FButtons[14] write FButtons[14];
    property Button15Key : KeyCode read FKeys[14]    write FKeys[14];
    property Button15Msg : String  read FMsgs[14]    write FMsgs[14];
    property Button16    : TButton read FButtons[15] write FButtons[15];
    property Button16Key : KeyCode read FKeys[15]    write FKeys[15];
    property Button16Msg : String  read FMsgs[15]    write FMsgs[15];
    property Button17    : TButton read FButtons[16] write FButtons[16];
    property Button17Key : KeyCode read FKeys[16]    write FKeys[16];
    property Button17Msg : String  read FMsgs[16]    write FMsgs[16];
    property Button18    : TButton read FButtons[17] write FButtons[17];
    property Button18Key : KeyCode read FKeys[17]    write FKeys[17];
    property Button18Msg : String  read FMsgs[17]    write FMsgs[17];
    property Button19    : TButton read FButtons[18] write FButtons[18];
    property Button19Key : KeyCode read FKeys[18]    write FKeys[18];
    property Button19Msg : String  read FMsgs[18]    write FMsgs[18];
    property Button20    : TButton read FButtons[19] write FButtons[19];
    property Button20Key : KeyCode read FKeys[19]    write FKeys[19];
    property Button20Msg : String  read FMsgs[19]    write FMsgs[19];

    property Enabled  : Boolean read FEnabled write SetFEnabled default False;

    Property OnShiftDown:TNotifyEvent read FOnShiftDown write FOnShiftDown;
    Property OnShiftUp:TNotifyEvent read FOnShiftUp write FOnShiftUp;


  end;

procedure Register;

implementation

function TBtnMng.GetShiftStatus:Boolean;
begin
  Result :=   FShiftStatus;
end;


//-----------------------------------------------------------------
// On Message
procedure TBtnMng.NewMessage(var Msg: TMsg; var Handled: Boolean);

  // down msg of shift
  procedure DoDownShift;
  var
    nn:Integer;
  begin

   if not FShiftStatus then begin
     FShiftStatus := True;
     for nn:= 0 to MAX_TABLE-1 do begin
       if Assigned(FButtons[nn]) then begin
         if FMsgs[nn] <> '' then begin
           FMsgBacks[nn] := FButtons[nn].Caption;
           FButtons[nn].Caption := FMsgs[nn];
         end;
       end;
     end;
     if Assigned(FOnShiftDown) then
       FOnShiftDown(self);
   end;

  end;

  // up msg of shift
  procedure DoUpShift;
  var
    nn:Integer;
  begin
   if FShiftStatus then begin
     FShiftStatus := False;
     for nn:= 0 to MAX_TABLE-1 do begin
       if Assigned(FButtons[nn]) then begin
         if FMsgBacks[nn] <> '' then begin
           FButtons[nn].Caption := FMsgBacks[nn];
           FMsgBacks[nn] := '';
         end;
       end;
     end;
     if Assigned(FOnShiftUp) then
       FOnShiftUp(self);
   end;
  end;

  // down msg of any
  procedure DoDownMsg( vv:KeyCode );
  var
    nn:Integer;
  begin
   for nn:= 0 to MAX_TABLE-1 do begin
     if Assigned(FButtons[nn]) and (FButtons[nn].Enabled)
          and (FKeys[nn] = vv) then begin
       FKeyDownStatus := True;          // Key Down!
       PostMessage(FButtons[nn].Handle,WM_LBUTTONDOWN,MK_LBUTTON,0);
     end;
   end;
  end;

  // up msg of any
  procedure DoUpMsg( vv:KeyCode );
  var
    nn:Integer;
  begin
   for nn:= 0 to MAX_TABLE-1 do begin
     if Assigned(FButtons[nn]) and (FButtons[nn].Enabled) and (FKeys[nn] = vv) then begin
       // lost of WM_LBUTTONDOWN.
       PostMessage(FButtons[nn].Handle,WM_LBUTTONDOWN,MK_LBUTTON,0);
       PostMessage(FButtons[nn].Handle,WM_LBUTTONUP,0,0);
     end;
   end;
  end;


begin

  if not FSleep then begin
    if (Msg.message = WM_LBUTTONDOWN) or (Msg.message = WM_KEYDOWN) then
      if not FKeyDownStatus then
        FOLDFocus := GetFocus;             // keep old focus;
    case Msg.message of
      WM_LBUTTONUP:
          FKeyDownStatus := False;         // Key Up!

      WM_KEYDOWN:                          // Key Down Event for F-1 to F-9
        begin
          FLastKeyCode := Msg.wParam;
          case Msg.wParam of
            VK_F1:    DoDownMsg( VF01 );   // F-1
            VK_F2:    DoDownMsg( VF02 );   // F-2
            VK_F3:    DoDownMsg( VF03 );   // F-3
            VK_F4:    DoDownMsg( VF04 );   // F-4
            VK_F5:    DoDownMsg( VF05 );   // F-5
            VK_F6:    DoDownMsg( VF06 );   // F-6
            VK_F7:    DoDownMsg( VF07 );   // F-7
            VK_F8:    DoDownMsg( VF08 );   // F-8
            VK_F9:    DoDownMsg( VF09 );   // F-9
            VK_ESCAPE:DoDownMsg( VESC );   // ESC
            VK_DELETE:DoDownMsg( VDEL );   // DEL
            VK_DOWN:  DoDownMsg( VDOWN );  // DOWN
            VK_UP:    DoDownMsg( VUP );    // UP
            VK_END:   DoDownMsg( VEND );   // HELP/END
            VK_HOME:  DoDownMsg( VHOME );  // HOME
            VK_INSERT:DoDownMsg( VINS );   // INS
            VK_LEFT:  DoDownMsg( VLEFT );  // LEFT
            VK_RIGHT: DoDownMsg( VRIGHT ); // RIGHT
            VK_NEXT: DoDownMsg( VRUP );    // ROLL UP / PAGE DOWN
            VK_PRIOR:  DoDownMsg( VRDOWN );// ROLL DOWN / PAGE UP
            VK_SHIFT: DoDownShift;         // SHIFT
          end;
        end;
      WM_KEYUP:                            // Key up Event for F-1 to F-9
        begin
          case Msg.wParam of
            VK_F1:    DoUpMsg( VF01 );     // F-1
            VK_F2:    DoUpMsg( VF02 );     // F-2
            VK_F3:    DoUpMsg( VF03 );     // F-3
            VK_F4:    DoUpMsg( VF04 );     // F-4
            VK_F5:    DoUpMsg( VF05 );     // F-5
            VK_F6:    DoUpMsg( VF06 );     // F-6
            VK_F7:    DoUpMsg( VF07 );     // F-7
            VK_F8:    DoUpMsg( VF08 );     // F-8
            VK_F9:    DoUpMsg( VF09 );     // F-9
            VK_ESCAPE:DoUpMsg( VESC );     // ESC
            VK_DELETE:DoUpMsg( VDEL );     // DEL
            VK_DOWN:  DoUpMsg( VDOWN );    // DOWN
            VK_UP:    DoUpMsg( VUP );      // UP
            VK_END:   DoUpMsg( VEND );     // HELP/END
            VK_HOME:  DoUpMsg( VHOME );    // HOME
            VK_INSERT:DoUpMsg( VINS );     // INS
            VK_LEFT:  DoUpMsg( VLEFT );    // LEFT
            VK_RIGHT: DoUpMsg( VRIGHT );   // RIGHT
            VK_NEXT:  DoUpMsg( VRUP );     // ROLL UP / PAGE DOWN
            VK_PRIOR: DoUPMsg( VRDOWN );   // ROLL DOWN / PAGE UP
            VK_SHIFT: DoUpShift;           // SHIFT
          end;
        end;
      WM_SYSKEYDOWN:                       // Key Down Event for F-10
        begin
          DoDownMsg( VF10 );
          FLastKeyCode := Msg.wParam;
          FKeyDownStatus := True;          // Key Down!
        end;
      WM_SYSKEYUP:                         // Key Down Event for F-10
        begin
          DoUpMsg( VF10 );
          FKeyDownStatus := False;         // Key Up!
        end;
    end; // end of case Msg.message of
  end else begin
    // for Button Caption!
    if Msg.message = WM_KEYDOWN then begin
      FLastKeyCode := Msg.wParam;
      if Msg.wParam = VK_SHIFT then       // Shift key Down!
        DoDownShift;
    end;
    if Msg.message = WM_KEYUP then begin
      if Msg.wParam = VK_SHIFT then       // Shift Key up!
        DoUpShift;
    end;
  end; // if not FSleep then begin

  // inherited OnMessage.
  if Assigned(FOldOnMessage) then
    FOldOnMessage(Msg,Handled);

end;


//-----------------------------------------------------------------
// move old focus
procedure TBtnMng.MoveOldFocus;
begin
  if FOLDFocus <> 0 then
    SetFocus(FOLDFocus);
end;


//-----------------------------------------------------------------
// Push Old Focus
procedure TBtnMng.Push;
begin
  FLastKeyCode := 0;
  FSleep := True;
  FPushOldFocus := 0;
  if FOLDFocus <> 0 then
    FPushOldFocus := FOLDFocus;
end;


//-----------------------------------------------------------------
// Pop Old Focus
procedure TBtnMng.Pop;
var
  Msg2: TMsg;
begin
  if FLastKeyCode = VK_ESCAPE then begin
    Sleep(GetDoubleClickTime);
    while PeekMessage( Msg2, 0, WM_KEYFIRST, WM_KEYLAST, PM_REMOVE ) do begin
 //   TranslateMessage(Msg2);
 //   DispatchMessage(Msg2);
    end;
  end;

  if FPushOldFocus <> 0 then
    FOLDFocus := FPushOldFocus;
  FPushOldFocus := 0;
  MoveOldFocus;
  FKeyDownStatus := False;         // Key Up!
  FSleep := False;
end;




//-----------------------------------------------------------------
// Create
constructor TBtnMng.Create(aowner : TComponent);
var
  n:integer;
begin
  inherited Create(aowner);
  FEnabled      := False;
  FOldOnMessage := NIL;

  for n := 0 to MAX_TABLE -1 do
    FMsgBacks[n] := '';

  FShiftStatus := False;
  FKeyDownStatus := False;

  FOLDFocus := 0;
  FPushOLDFocus := 0;
  FSleep := False;

  FLastKeyCode := 0;


end;


//-----------------------------------------------------------------
// Destroy
destructor TBtnMng.Destroy;
begin
  inherited Destroy;
end;


//-----------------------------------------------------------------
// Set Enabled
procedure TBtnMng.SetFEnabled( v:Boolean );
begin
  if v then begin
    if not FEnabled then begin
      if Assigned(Application.OnMessage) then
        FOldOnMessage := Application.OnMessage
      else
        FOldOnMessage := NIL;
      Application.OnMessage := NewMessage;
    end;
  end else begin
    if FEnabled then begin
      if Assigned(FOldOnMessage) then
        Application.OnMessage := FOldOnMessage
      else
        Application.OnMessage := NIL;
    end;
  end;
  FEnabled := v;
end;


//-----------------------------------------------------------------
// Register
procedure Register;
begin
  RegisterComponents('Samples', [TBtnMng]);
end;



end.
